package farm.ants.plugins;
import farm.simulator.*;
import java.rmi.*;
import farm.ants.agent.SlotSchedule;

/**
 * This class describes a sensor in the environment
 * <p>
 * Created: Tue Jul  9 14:16:09 2002
 *
 * @author Roger Mailler
 */
public class SensorModel extends ObjectModel {
    int slotCount = 3;
    
    public SensorModel(FarmPlugIn FPI, String n){
	super(FPI, n);
    }
    public SensorModel(FarmPlugIn FPI, String n, float X, float Y, float R) {
	super(FPI, n, X, Y);
	setRadius(R);
    }

    float radius = -1;
    
    /**
     * Get the value of radius.
     * @param vol true local copy volatile
     * @return Value of radius.
     */
    public float getRadius(boolean vol) {
	if(radius == -1 || vol) {
            Object prop = fpi.getProperty(name + ":radius");
            if(prop != null)
                radius = ((Float) prop).floatValue();
            else
                radius = -1f;
	}      	
	return radius;
    }
    
    /**
     * Set the value of radius.
     * @param v  Value to assign to radius.
     */
    public void setRadius(float  v) {
	fpi.setProperty(name + ":radius", new Float(v));
	this.radius = v;
    }

    /**
     * Get the sensor's schedule
     * @return The schedule
     */
    public SlotSchedule getSchedule() {
        SlotSchedule SS = new SlotSchedule();
        String sched = (String)fpi.getProperty(name + ":sched");
        if (sched != null) {
            SS.fromPiggyBack(sched);
        }
        return SS;
    }
} // SensorModel
