#include <jvmpi.h>
#include <jni.h>
#include <stdio.h>

#ifdef _linux_
#define TIME_SCALE 1000
#endif
#ifdef _macosx_
#define TIME_SCALE 100000
#endif

// profiler agent entry point
extern "C" {

// global jvmpi interface pointer
static JVMPI_Interface *jvmpi_interface = NULL;

  JNIEXPORT jint JNICALL JVM_OnLoad(JavaVM *jvm, char *options, void *reserved) {
  
    // get jvmpi interface pointer
    int err = jvm->GetEnv((void **)&jvmpi_interface, JVMPI_VERSION_1);
    if (err < 0 || jvmpi_interface == 0) {
      fprintf(stderr, "Error %d loading jvmpi\n", err);
      return err;
    }
    
    fprintf(stderr, "Successfully loaded jvmpi: 0x%x\n", jvmpi_interface);
    return JNI_OK;
  }

  JNIEXPORT jlong JNICALL Java_farm_metagent_JProf_getThreadTime(JNIEnv *env, jclass) {
  
    // test jvmpi
    if (jvmpi_interface == 0) {
      JavaVM *	jvms[1];
      jsize		num;
      JNI_GetCreatedJavaVMs(jvms, 1, &num);
      fprintf(stderr, "Warning: trying to regain jvmpi_interface\n");
      if (num > 0) {
      	jvms[0]->GetEnv((void **)&jvmpi_interface, JVMPI_VERSION_1);
      }
    }

    // return 0 if agent not initialized
    if (jvmpi_interface == 0) {
      fprintf(stderr, "Error: jvmpi_interface not initialized\n");
      return 0;
    } else {
      //fprintf(stderr, "Thread: %x\n", env);
      return (jvmpi_interface->GetCurrentThreadCpuTime() / TIME_SCALE);
    }
  }
}

